﻿using UnityEngine;
using System.Collections;

public class spheresound : MonoBehaviour {
	// RTcmix/audio stuff
	private int objno = 0;
	private rtcmixmain RTcmix;
	float heightamp;


	// Use this for initialization
	void Start () {
		RTcmix = GameObject.Find ("RTcmixmain").GetComponent<rtcmixmain> ();
		RTcmix.initRTcmix (objno);

		RTcmix.SendScore ("MAXBANG(0.1)", objno); // this is to allow RTcmix to get initialized
		heightamp = 0.5f; // this is the default set in the "makeconnection()" score fragmet below
	}


	// Update is called once per frame
	void Update () {
		if (Input.GetKeyDown (KeyCode.UpArrow)) {
			transform.Translate (0.0f, 0.1f, 0.0f);
			// increase the "heightamp" value and send it to RTcmix
			heightamp += 0.1f;
			RTcmix.setpfieldRTcmix (1, heightamp, objno);
		}
		if (Input.GetKeyDown (KeyCode.DownArrow)) {
			transform.Translate (0.0f, -0.1f, 0.0f);
			// decrease the "heightamp" value and send it to RTcmix
			heightamp -= 0.1f;
			RTcmix.setpfieldRTcmix (1, heightamp, objno);
		}
	}


	void OnAudioFilterRead(float[] data, int channels) {
		RTcmix.runRTcmix (data, objno, 0);

		if (RTcmix.checkbangRTcmix (objno) == 1) {
			// the "makeconnection()" allows the "ampctrl" value to come from the RTcmix.setpfieldRTcmix() functions
			RTcmix.SendScore ("ampctrl = makeconnection(\"inlet\", 1, 0.5)  " +
			"WAVETABLE(0, 9999, 7000*ampctrl, 8.00) " +
			"WAVETABLE(0, 9999, 7000*ampctrl, 8.04) " +
			"WAVETABLE(0, 9999, 7000*ampctrl, 8.07) ", objno);
		}
	}


	void OnApplicationQuit() {
		RTcmix.destroy (objno);
	}
}
